using System;
using System.Collections.Generic;
using System.Text;
using System.Xml;
using System.Xml.Xsl;
using SDA.DataProvider;

//XSLCompiled Transformation Class
//Released to public! If You use this, please drop me a letter, or a beer! ;)
//Copyright 2010. Gabor Keve
//Send me feedback to gabor@keve.info

namespace Sagitta
{
    class Transformation
    {
        public string DoTransform(string xml, string xsl)
        {
            System.IO.MemoryStream memstr = new System.IO.MemoryStream(Encoding.Default.GetBytes(xml));
            System.IO.StringWriter sw = new System.IO.StringWriter();
            System.Xml.XPath.XPathDocument myXPathDoc = new System.Xml.XPath.XPathDocument(memstr);
            System.Xml.Xsl.XslCompiledTransform Trans = new System.Xml.Xsl.XslCompiledTransform(true);
            System.Xml.XmlDocument xsldoc = new XmlDocument();
            xsldoc.LoadXml(xsl);
            Trans.Load(xsldoc);
            Trans.Transform(myXPathDoc, null, sw);
            return sw.ToString();
        }

        public string DoTransformation(System.IO.MemoryStream xml, string xsl)
        {
            System.IO.StringWriter sw = new System.IO.StringWriter();
            System.Xml.XPath.XPathDocument myXPathDoc = new System.Xml.XPath.XPathDocument(xml);
            System.Xml.Xsl.XslCompiledTransform Trans = new System.Xml.Xsl.XslCompiledTransform(true);
            System.Xml.XmlDocument xsldoc = new XmlDocument();
            xsldoc.LoadXml(xsl);
            Trans.Load(xsldoc);
            Trans.Transform(myXPathDoc, null, sw);
            return sw.ToString();
        }

        public string DoTransformation(System.IO.MemoryStream xml, System.IO.MemoryStream xsl)
        {
            System.IO.StringWriter sw = new System.IO.StringWriter();
            System.Xml.XPath.XPathDocument myXPathDoc = new System.Xml.XPath.XPathDocument(xml);
            System.Xml.Xsl.XslCompiledTransform Trans = new System.Xml.Xsl.XslCompiledTransform(true);
            System.Xml.XmlDocument xsldoc = new XmlDocument();
            xsldoc.Load(xsl);
            Trans.Load(xsldoc);
            Trans.Transform(myXPathDoc, null, sw);
            return sw.ToString();
        }

        public System.Xml.XmlDocument DoTransformation(System.Xml.XmlDocument xml, System.Xml.XmlDocument xsl)
        {
            System.IO.StringWriter sw = new System.IO.StringWriter();
            System.IO.MemoryStream memstr = new System.IO.MemoryStream(Encoding.Default.GetBytes(xml.OuterXml));
            System.Xml.XPath.XPathDocument myXPathDoc = new System.Xml.XPath.XPathDocument(memstr);
            System.Xml.Xsl.XslCompiledTransform Trans = new System.Xml.Xsl.XslCompiledTransform(true);
            System.Xml.XmlDocument xsldoc = new XmlDocument();
            xsldoc.LoadXml(xsl.OuterXml);
            Trans.Load(xsldoc);
            Trans.Transform(myXPathDoc, null, sw);
            System.Xml.XmlDocument res = new XmlDocument();
            res.LoadXml(sw.ToString());
            return res;
        }
    }
}

//Example
//using XslTransformation;
//public void NeedToTransformTheXML(string InputXmlFile, string OutputXmlFile, string XslFile)
//{
//   System.IO.Xml.XmlDocument m_xmlfile = new XmlDocument();
//   System.IO.Xml.XmlDocument m_xslfile = new XmlDocument();
//   System.IO.Xml.XmlDocument m_resultfile = new XmlDocument();
//   m_xmlfile.Load(XmlFile);
//   m_xslfile.Load(XslFile);
//   m_resultfile = new Transformation.DoTransformation(m_xmlfile, m_xslfile);
//   m_resultfile.Save(OutputXmlFile);
//}